OPTION _EXPLICIT
_TITLE "shell"
'$DYNAMIC

TYPE Credential
    correctUsername AS _UNSIGNED _INTEGER64
    correctPassword AS _UNSIGNED _INTEGER64
END TYPE

CONST Zero = 0: CONST Infinity = 18446744073709551615: CONST true = -1: CONST false = NOT true

DIM SHARED hashTable(1, 95) AS _UNSIGNED INTEGER

RESTORE positionHash
DIM Counter AS _UNSIGNED INTEGER
FOR Counter = 94 TO 0 STEP -1
    READ hashTable(1, Counter)
NEXT Counter

RESTORE characterHash
FOR Counter = 0 TO 94
    READ hashTable(0, Counter)
NEXT Counter

REDIM SHARED loginCredentials AS Credential
DIM SHARED Username AS STRING: DIM SHARED uInput AS _UNSIGNED _INTEGER64: DIM User AS _BIT: DIM SHARED userLevel AS _UNSIGNED INTEGER
DIM SHARED pInput AS _UNSIGNED _INTEGER64: DIM Successful AS _BIT
'
' Run strings through the encode function in order to get proper values for the Username and Password.
'
'                                                                                   ,- Here is the encoded Password (change this)
'                                                                                   V
loginCredentials.correctUsername = 41017948: loginCredentials.correctPassword = 140956205
'                                      A
'                                      `- Here is the encoded Username (change this)
'

DIM fullScreenResolutionX AS INTEGER: fullScreenResolutionX = _DESKTOPWIDTH: DIM fullScreenResolutionY AS INTEGER: fullScreenResolutionY = _DESKTOPHEIGHT
DIM windowedResolutionX AS _UNSIGNED INTEGER: windowedResolutionX = 1024: DIM windowedResolutionY AS _UNSIGNED INTEGER: windowedResolutionY = 480
SCREEN _NEWIMAGE(windowedResolutionX, windowedResolutionY, 12): _FULLSCREEN _OFF: _PRINTMODE _KEEPBACKGROUND: CLS

DIM SHARED backC AS _UNSIGNED LONG: backC = 0: DIM SHARED backupBackC: DIM SHARED textC AS _UNSIGNED LONG: textC = 15: DIM SHARED backupTextC
DIM SHARED red, green, blue

DIM SHARED errorLevel AS _UNSIGNED _BYTE

User = -1: Successful = -1

IF User = -1 THEN userLevel = 4

'
' User code below
'

KEY 1, UCASE$("help") + CHR$(13)
KEY 2, "" + CHR$(13)
KEY 3, "" + CHR$(13)
KEY 4, "" + CHR$(13)
KEY 5, "" + CHR$(13)
KEY 6, UCASE$("window") + CHR$(13)
KEY 7, UCASE$("screen") + CHR$(13)
KEY 8, UCASE$("color") + CHR$(13)
KEY 9, UCASE$("invert") + CHR$(13)
KEY 10, UCASE$("quit") + CHR$(13)
KEY 30, UCASE$("debug") + CHR$(13)
KEY 31, UCASE$("about") + CHR$(13)

KEY ON
DO
    DIM cmd AS STRING
    INPUT "> ", cmd
    cmd = LTRIM$(RTRIM$(UCASE$(cmd)))

    IF cmd = "" THEN
        errorLevel = 2
    ELSE
        errorLevel = 1
    END IF

    IF cmd = "DATE" THEN
        PRINT "": PRINT "The current date is: " + DATE$: PRINT "": errorLevel = 0
    END IF

    IF cmd = "TIME" THEN
        PRINT "": PRINT "The current time is: " + TIME$: PRINT "": errorLevel = 0
    END IF

    IF cmd = "CLS" THEN
        CLS: errorLevel = 0
    END IF

    IF cmd = "HELP" THEN
        PRINT "": PRINT "Available Commands: ": PRINT ""
        PRINT "date, time, cls, color, screen, window, quit, about, help, debug": PRINT "": errorLevel = 0
    END IF

    IF cmd = "2" THEN
        errorLevel = 0
    END IF

    IF cmd = "3" THEN
        errorLevel = 0
    END IF

    IF cmd = "4" THEN
        errorLevel = 0
    END IF

    IF cmd = "5" THEN
        errorLevel = 0
    END IF

    IF cmd = "WINDOW" THEN
        SCREEN _NEWIMAGE(windowedResolutionX, windowedResolutionY, 12)
        _FULLSCREEN _OFF: _PRINTMODE _KEEPBACKGROUND
        colorTransition: errorLevel = 0
    END IF

    IF cmd = "SCREEN" THEN
        SCREEN _NEWIMAGE(_DESKTOPWIDTH, _DESKTOPHEIGHT, 12)
        _FULLSCREEN: _PRINTMODE _KEEPBACKGROUND
        colorTransition: errorLevel = 0
    END IF

    IF cmd = "COLOR" THEN
        colorSet: errorLevel = 0
    END IF

    IF cmd = "INVERT" THEN
        colorInvert: errorLevel = 0
    END IF

    IF cmd = "QUIT" THEN SYSTEM

    IF cmd = "DEBUG" THEN
        errorLevel = 0
    END IF

    IF cmd = "ABOUT" THEN
        PRINT "": PRINT "Modular OS/3"
        PRINT "Master Control Program"
        PRINT "Version 0.95a": PRINT "": errorLevel = 0
    END IF

    errorHandler

LOOP: KEY OFF: END

'
' User code above
'

characterHash:
DATA 2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53
DATA 59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131
DATA 137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223
DATA 227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311
DATA 313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409
DATA 419,421,431,433,439,443,449,457,461,463,467,479,487,491,499

positionHash:
DATA 9157,9161,9173,9181,9187,9199,9203,9209,9221,9227,9239,9241,9257,9277,9281
DATA 9283,9293,9311,9319,9323,9337,9341,9343,9349,9371,9377,9391,9397,9403,9413,9419
DATA 9421,9431,9433,9437,9439,9461,9463,9467,9473,9479,9491,9497,9511,9521,9533,9539
DATA 9547,9551,9587,9601,9613,9619,9623,9629,9631,9643,9649,9661,9677,9679,9689,9697
DATA 9719,9721,9733,9739,9743,9749,9767,9769,9781,9787,9791,9803,9811,9817,9829,9833
DATA 9839,9851,9857,9859,9871,9883,9887,9901,9907,9923,9929,9931,9941,9949,9967,9973

FUNCTION Encode~&& (stringInput AS STRING)
stringInput = LTRIM$(RTRIM$(stringInput)): DIM stringLength AS _UNSIGNED INTEGER: stringLength = LEN(stringInput)
DIM characterPosition AS _UNSIGNED INTEGER: FOR characterPosition = 0 TO stringLength
    DIM currentCharacter AS STRING: currentCharacter = MID$(stringInput, characterPosition, 1)
    SELECT CASE currentCharacter
        CASE CHR$(&O040): Encode = Encode + (hashTable(0, 83) * (hashTable(1, 63) * characterPosition))
        CASE CHR$(&O041): Encode = Encode + (hashTable(0, 33) * (hashTable(1, 53) * characterPosition))
        CASE CHR$(&O042): Encode = Encode + (hashTable(0, 23) * (hashTable(1, 58) * characterPosition))
        CASE CHR$(&O043): Encode = Encode + (hashTable(0, 90) * (hashTable(1, 6) * characterPosition))
        CASE CHR$(&O044): Encode = Encode + (hashTable(0, 59) * (hashTable(1, 71) * characterPosition))
        CASE CHR$(&O045): Encode = Encode + (hashTable(0, 34) * (hashTable(1, 8) * characterPosition))
        CASE CHR$(&O046): Encode = Encode + (hashTable(0, 12) * (hashTable(1, 69) * characterPosition))
        CASE CHR$(&O047): Encode = Encode + (hashTable(0, 94) * (hashTable(1, 37) * characterPosition))
        CASE CHR$(&O050): Encode = Encode + (hashTable(0, 30) * (hashTable(1, 62) * characterPosition))
        CASE CHR$(&O051): Encode = Encode + (hashTable(0, 66) * (hashTable(1, 93) * characterPosition))
        CASE CHR$(&O052): Encode = Encode + (hashTable(0, 14) * (hashTable(1, 9) * characterPosition))
        CASE CHR$(&O053): Encode = Encode + (hashTable(0, 75) * (hashTable(1, 49) * characterPosition))
        CASE CHR$(&O054): Encode = Encode + (hashTable(0, 15) * (hashTable(1, 51) * characterPosition))
        CASE CHR$(&O055): Encode = Encode + (hashTable(0, 36) * (hashTable(1, 14) * characterPosition))
        CASE CHR$(&O056): Encode = Encode + (hashTable(0, 20) * (hashTable(1, 84) * characterPosition))
        CASE CHR$(&O057): Encode = Encode + (hashTable(0, 46) * (hashTable(1, 85) * characterPosition))
        CASE CHR$(&O060): Encode = Encode + (hashTable(0, 21) * (hashTable(1, 48) * characterPosition))
        CASE CHR$(&O061): Encode = Encode + (hashTable(0, 45) * (hashTable(1, 64) * characterPosition))
        CASE CHR$(&O062): Encode = Encode + (hashTable(0, 40) * (hashTable(1, 29) * characterPosition))
        CASE CHR$(&O063): Encode = Encode + (hashTable(0, 85) * (hashTable(1, 30) * characterPosition))
        CASE CHR$(&O064): Encode = Encode + (hashTable(0, 56) * (hashTable(1, 19) * characterPosition))
        CASE CHR$(&O065): Encode = Encode + (hashTable(0, 2) * (hashTable(1, 87) * characterPosition))
        CASE CHR$(&O066): Encode = Encode + (hashTable(0, 35) * (hashTable(1, 10) * characterPosition))
        CASE CHR$(&O067): Encode = Encode + (hashTable(0, 16) * (hashTable(1, 75) * characterPosition))
        CASE CHR$(&O070): Encode = Encode + (hashTable(0, 7) * (hashTable(1, 27) * characterPosition))
        CASE CHR$(&O071): Encode = Encode + (hashTable(0, 69) * (hashTable(1, 76) * characterPosition))
        CASE CHR$(&O072): Encode = Encode + (hashTable(0, 0) * (hashTable(1, 3) * characterPosition))
        CASE CHR$(&O073): Encode = Encode + (hashTable(0, 58) * (hashTable(1, 31) * characterPosition))
        CASE CHR$(&O074): Encode = Encode + (hashTable(0, 55) * (hashTable(1, 65) * characterPosition))
        CASE CHR$(&O075): Encode = Encode + (hashTable(0, 18) * (hashTable(1, 17) * characterPosition))
        CASE CHR$(&O076): Encode = Encode + (hashTable(0, 5) * (hashTable(1, 77) * characterPosition))
        CASE CHR$(&O077): Encode = Encode + (hashTable(0, 4) * (hashTable(1, 12) * characterPosition))
        CASE CHR$(&O100): Encode = Encode + (hashTable(0, 52) * (hashTable(1, 61) * characterPosition))
        CASE CHR$(&O101): Encode = Encode + (hashTable(0, 65) * (hashTable(1, 2) * characterPosition))
        CASE CHR$(&O102): Encode = Encode + (hashTable(0, 43) * (hashTable(1, 7) * characterPosition))
        CASE CHR$(&O103): Encode = Encode + (hashTable(0, 53) * (hashTable(1, 67) * characterPosition))
        CASE CHR$(&O104): Encode = Encode + (hashTable(0, 76) * (hashTable(1, 72) * characterPosition))
        CASE CHR$(&O105): Encode = Encode + (hashTable(0, 79) * (hashTable(1, 25) * characterPosition))
        CASE CHR$(&O106): Encode = Encode + (hashTable(0, 81) * (hashTable(1, 78) * characterPosition))
        CASE CHR$(&O107): Encode = Encode + (hashTable(0, 74) * (hashTable(1, 74) * characterPosition))
        CASE CHR$(&O110): Encode = Encode + (hashTable(0, 60) * (hashTable(1, 11) * characterPosition))
        CASE CHR$(&O111): Encode = Encode + (hashTable(0, 28) * (hashTable(1, 73) * characterPosition))
        CASE CHR$(&O112): Encode = Encode + (hashTable(0, 87) * (hashTable(1, 28) * characterPosition))
        CASE CHR$(&O113): Encode = Encode + (hashTable(0, 10) * (hashTable(1, 79) * characterPosition))
        CASE CHR$(&O114): Encode = Encode + (hashTable(0, 26) * (hashTable(1, 34) * characterPosition))
        CASE CHR$(&O115): Encode = Encode + (hashTable(0, 70) * (hashTable(1, 54) * characterPosition))
        CASE CHR$(&O116): Encode = Encode + (hashTable(0, 11) * (hashTable(1, 55) * characterPosition))
        CASE CHR$(&O117): Encode = Encode + (hashTable(0, 82) * (hashTable(1, 36) * characterPosition))
        CASE CHR$(&O120): Encode = Encode + (hashTable(0, 1) * (hashTable(1, 38) * characterPosition))
        CASE CHR$(&O121): Encode = Encode + (hashTable(0, 67) * (hashTable(1, 40) * characterPosition))
        CASE CHR$(&O122): Encode = Encode + (hashTable(0, 41) * (hashTable(1, 26) * characterPosition))
        CASE CHR$(&O123): Encode = Encode + (hashTable(0, 22) * (hashTable(1, 0) * characterPosition))
        CASE CHR$(&O124): Encode = Encode + (hashTable(0, 92) * (hashTable(1, 57) * characterPosition))
        CASE CHR$(&O125): Encode = Encode + (hashTable(0, 61) * (hashTable(1, 88) * characterPosition))
        CASE CHR$(&O126): Encode = Encode + (hashTable(0, 9) * (hashTable(1, 68) * characterPosition))
        CASE CHR$(&O127): Encode = Encode + (hashTable(0, 25) * (hashTable(1, 50) * characterPosition))
        CASE CHR$(&O130): Encode = Encode + (hashTable(0, 84) * (hashTable(1, 59) * characterPosition))
        CASE CHR$(&O131): Encode = Encode + (hashTable(0, 39) * (hashTable(1, 44) * characterPosition))
        CASE CHR$(&O132): Encode = Encode + (hashTable(0, 17) * (hashTable(1, 16) * characterPosition))
        CASE CHR$(&O133): Encode = Encode + (hashTable(0, 73) * (hashTable(1, 13) * characterPosition))
        CASE CHR$(&O134): Encode = Encode + (hashTable(0, 57) * (hashTable(1, 60) * characterPosition))
        CASE CHR$(&O135): Encode = Encode + (hashTable(0, 78) * (hashTable(1, 23) * characterPosition))
        CASE CHR$(&O136): Encode = Encode + (hashTable(0, 31) * (hashTable(1, 83) * characterPosition))
        CASE CHR$(&O137): Encode = Encode + (hashTable(0, 63) * (hashTable(1, 5) * characterPosition))
        CASE CHR$(&O140): Encode = Encode + (hashTable(0, 37) * (hashTable(1, 22) * characterPosition))
        CASE CHR$(&O141): Encode = Encode + (hashTable(0, 47) * (hashTable(1, 91) * characterPosition))
        CASE CHR$(&O142): Encode = Encode + (hashTable(0, 51) * (hashTable(1, 52) * characterPosition))
        CASE CHR$(&O143): Encode = Encode + (hashTable(0, 80) * (hashTable(1, 47) * characterPosition))
        CASE CHR$(&O144): Encode = Encode + (hashTable(0, 49) * (hashTable(1, 35) * characterPosition))
        CASE CHR$(&O145): Encode = Encode + (hashTable(0, 89) * (hashTable(1, 32) * characterPosition))
        CASE CHR$(&O146): Encode = Encode + (hashTable(0, 24) * (hashTable(1, 94) * characterPosition))
        CASE CHR$(&O147): Encode = Encode + (hashTable(0, 91) * (hashTable(1, 86) * characterPosition))
        CASE CHR$(&O150): Encode = Encode + (hashTable(0, 86) * (hashTable(1, 20) * characterPosition))
        CASE CHR$(&O151): Encode = Encode + (hashTable(0, 42) * (hashTable(1, 39) * characterPosition))
        CASE CHR$(&O152): Encode = Encode + (hashTable(0, 68) * (hashTable(1, 66) * characterPosition))
        CASE CHR$(&O153): Encode = Encode + (hashTable(0, 62) * (hashTable(1, 1) * characterPosition))
        CASE CHR$(&O154): Encode = Encode + (hashTable(0, 50) * (hashTable(1, 42) * characterPosition))
        CASE CHR$(&O155): Encode = Encode + (hashTable(0, 6) * (hashTable(1, 18) * characterPosition))
        CASE CHR$(&O156): Encode = Encode + (hashTable(0, 3) * (hashTable(1, 41) * characterPosition))
        CASE CHR$(&O157): Encode = Encode + (hashTable(0, 88) * (hashTable(1, 56) * characterPosition))
        CASE CHR$(&O160): Encode = Encode + (hashTable(0, 29) * (hashTable(1, 21) * characterPosition))
        CASE CHR$(&O161): Encode = Encode + (hashTable(0, 54) * (hashTable(1, 46) * characterPosition))
        CASE CHR$(&O162): Encode = Encode + (hashTable(0, 71) * (hashTable(1, 90) * characterPosition))
        CASE CHR$(&O163): Encode = Encode + (hashTable(0, 32) * (hashTable(1, 4) * characterPosition))
        CASE CHR$(&O164): Encode = Encode + (hashTable(0, 72) * (hashTable(1, 24) * characterPosition))
        CASE CHR$(&O165): Encode = Encode + (hashTable(0, 13) * (hashTable(1, 33) * characterPosition))
        CASE CHR$(&O166): Encode = Encode + (hashTable(0, 8) * (hashTable(1, 45) * characterPosition))
        CASE CHR$(&O167): Encode = Encode + (hashTable(0, 77) * (hashTable(1, 70) * characterPosition))
        CASE CHR$(&O170): Encode = Encode + (hashTable(0, 19) * (hashTable(1, 92) * characterPosition))
        CASE CHR$(&O171): Encode = Encode + (hashTable(0, 93) * (hashTable(1, 80) * characterPosition))
        CASE CHR$(&O172): Encode = Encode + (hashTable(0, 38) * (hashTable(1, 82) * characterPosition))
        CASE CHR$(&O173): Encode = Encode + (hashTable(0, 64) * (hashTable(1, 89) * characterPosition))
        CASE CHR$(&O174): Encode = Encode + (hashTable(0, 44) * (hashTable(1, 15) * characterPosition))
        CASE CHR$(&O175): Encode = Encode + (hashTable(0, 27) * (hashTable(1, 81) * characterPosition))
        CASE CHR$(&O176): Encode = Encode + (hashTable(0, 48) * (hashTable(1, 43) * characterPosition))
        CASE ELSE REM
END SELECT: NEXT characterPosition
END FUNCTION

SUB errorHandler
IF errorLevel = 0 THEN GOTO noError
PRINT "": IF errorLevel = 1 THEN PRINT "ERROR: Invalid Commandname! (Code " + LTRIM$(STR$(errorLevel)) + ")"
IF errorLevel = 2 THEN PRINT "ERROR: Buffer is Empty! (Code " + LTRIM$(STR$(errorLevel)) + ")"
IF errorLevel = 3 THEN PRINT "ERROR: Invalid username or password! (Code " + LTRIM$(STR$(errorLevel)) + ")"
PRINT "": errorLevel = 0
noError:
END SUB

SUB UsernameInput
uInput = 0: WHILE uInput = 0
    INPUT "username> ", Username
    uInput = Encode(LTRIM$(RTRIM$(UCASE$(Username))))
WEND
END SUB

SUB PasswordInput
pInput = 0: WHILE pInput = 0
    PRINT "password> ";
    DIM Password AS STRING: COLOR backC: INPUT "", Password: COLOR textC
    pInput = Encode(LTRIM$(RTRIM$(Password)))
WEND
END SUB

SUB colorSet
OUT &H3C8, 0: OUT &H3C9, 0: OUT &H3C9, 0: OUT &H3C9, 0
COLOR: PRINT "": DIM c: c = 1
incrcolor:
COLOR c: PRINT c;
c = c + 1: IF c <= 15 THEN GOTO incrcolor: c = 15: COLOR c
PRINT: PRINT
INPUT "input numeric value of background color: ", backC
OUT &H3C7, backC: DIM red: red = INP(&H3C9): DIM green: green = INP(&H3C9): DIM blue: blue = INP(&H3C9)
OUT &H3C8, 0: OUT &H3C9, red: OUT &H3C9, green: OUT &H3C9, blue
INPUT "input numeric value of text color: ", textC
IF backC = 0 THEN
    IF textC = 0 THEN textC = 15
END IF: COLOR textC: CLS
END SUB

SUB colorInvert
IF backC <> 0 THEN
    backupTextC = textC: textC = backC: COLOR textC: backC = backupTextC
    OUT &H3C7, backC: DIM red: red = INP(&H3C9): DIM green: green = INP(&H3C9): DIM blue: blue = INP(&H3C9)
    OUT &H3C8, 0: OUT &H3C9, red: OUT &H3C9, green: OUT &H3C9, blue: CLS
END IF
END SUB

SUB colorTransition
OUT &H3C7, backC: red = INP(&H3C9): green = INP(&H3C9): blue = INP(&H3C9)
OUT &H3C8, 0: OUT &H3C9, red: OUT &H3C9, green: OUT &H3C9, blue
COLOR textC: KEY OFF: KEY ON
END SUB

